Attribute VB_Name = "WinApi"
Option Explicit

' Kernel32 api-cals
Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

' Gdi32 api-cals (Graphics)
Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Declare Function Rectangle Lib "gdi32" (ByVal hdc As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Declare Function CreatePen Lib "gdi32" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long) As Long
Declare Function CreateFont Lib "gdi32" Alias "CreateFontA" (ByVal H As Long, ByVal W As Long, ByVal E As Long, ByVal O As Long, ByVal W As Long, ByVal I As Long, ByVal u As Long, ByVal S As Long, ByVal C As Long, ByVal OP As Long, ByVal CP As Long, ByVal Q As Long, ByVal PAF As Long, ByVal F As String) As Long
Declare Function DrawTextA Lib "user32" (ByVal hdc As Long, ByVal lpStr As String, ByVal nCount As Long, lpRect As Rect, ByVal wFormat As Long) As Long
Declare Function TextOut Lib "gdi32" Alias "TextOutA" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal lpString As String, ByVal nCount As Long) As Long
Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Declare Function SetTextColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long
Declare Function SetBkMode Lib "gdi32" (ByVal hdc As Long, ByVal nBkMode As Long) As Long
Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Declare Function SetPixelV Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal crColor As Long) As Long

' For the possibility to move the forms Name and Login
Declare Function ReleaseCapture Lib "user32" () As Long
Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long

' To get info from the system-register
Declare Function RegOpenKeyEx Lib "advapi32" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, ByRef phkResult As Long) As Long
Declare Function RegQueryValueEx Lib "advapi32" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, ByRef lpType As Long, ByVal lpData As String, ByRef lpcbData As Long) As Long
Declare Function RegCloseKey Lib "advapi32" (ByVal hKey As Long) As Long

' For deleting the exit-button in form about
Declare Function GetSystemMenu Lib "user32" (ByVal hwnd As Long, ByVal bRevert As Long) As Long
Declare Function GetMenuItemCount Lib "user32" (ByVal hMenu As Long) As Long
Declare Function DrawMenuBar Lib "user32" (ByVal hwnd As Long) As Long
Declare Function RemoveMenu Lib "user32" (ByVal hMenu As Long, ByVal nPosition As Long, ByVal wFlags As Long) As Long

Type Rect
Left As Long
Top As Long
Right As Long
Bottom As Long
End Type

Type Buffer
hdc As Long
Picture As Long
Brush As Long
Font As Long
Pen As Long
Rect As Rect
ScaleWidth As Integer
ScaleHeight As Integer
End Type

Type POINTAPI
X As Long
Y As Long
End Type

Type SkylderTextBox
Text As String
BackColor As Long
LineColor As Long
TextColor As Long
ScaleWidth As Integer
ScaleHeight As Integer
End Type

' For the possibility to move the form Name and Login
Global Const HTCAPTION = 2
Global Const WM_NCLBUTTONDOWN = &HA1

' For the createfont
Global Const FW_NORMAL = 400
Global Const FW_BOLD = 700
Global Const OEM_CHARSET = 255
Global Const OEM_FIXED_FONT = 10
Global Const OUT_DEFAULT_PRECIS = 0
Global Const CLIP_DEFAULT_PRECIS = 0
Global Const CLIP_MASK = &HF
Global Const TRANSPARENT = 1
Global Const DEFAULT_QUALITY = 0
Global Const DRAFT_QUALITY = 1
Global Const PROOF_QUALITY = 2

' For the DrawTextA api
Global Const DT_BOTTOM = &H8
Global Const DT_CALCRECT = &H400
Global Const DT_CENTER = &H1
Global Const DT_CHARSTREAM = 4
Global Const DT_DISPFILE = 6
Global Const DT_EXPANDTABS = &H40
Global Const DT_EXTERNALLEADING = &H200
Global Const DT_INTERNAL = &H1000
Global Const DT_LEFT = &H0
Global Const DT_METAFILE = 5
Global Const DT_NOPREFIX = &H800
Global Const DT_NOCLIP = &H100
Global Const DT_PLOTTER = 0
Global Const DT_RASCAMERA = 3
Global Const DT_RASDISPLAY = 1
Global Const DT_RASPRINTER = 2
Global Const DT_RIGHT = &H2
Global Const DT_SINGLELINE = &H20
Global Const DT_TABSTOP = &H80
Global Const DT_TOP = &H0
Global Const DT_VCENTER = &H4
Global Const DT_WORDBREAK = &H10

' Getting information from the system registry
Global Const READ_CONTROL = &H20000
Global Const KEY_QUERY_VALUE = &H1
Global Const KEY_SET_VALUE = &H2
Global Const KEY_CREATE_SUB_KEY = &H4
Global Const KEY_ENUMERATE_SUB_KEYS = &H8
Global Const KEY_NOTIFY = &H10
Global Const KEY_CREATE_LINK = &H20
Global Const KEY_ALL_ACCESS = KEY_QUERY_VALUE + KEY_SET_VALUE + KEY_CREATE_SUB_KEY + KEY_ENUMERATE_SUB_KEYS + KEY_NOTIFY + KEY_CREATE_LINK + READ_CONTROL
Global Const HKEY_LOCAL_MACHINE = &H80000002
Global Const ERROR_SUCCESS = 0
Global Const REG_SZ = 1
Global Const REG_DWORD = 4
Global Const gREGKEYSYSINFOLOC = "SOFTWARE\Microsoft\Shared Tools Location"
Global Const gREGVALSYSINFOLOC = "MSINFO"
Global Const gREGKEYSYSINFO = "SOFTWARE\Microsoft\Shared Tools\MSINFO"
Global Const gREGVALSYSINFO = "PATH"

' For deleting the exit-button in form about
Global Const MF_BYPOSITION = &H400&
Global Const MF_REMOVE = &H1000&

Public CancelIt As Boolean
Public hQueue As Long, Y%, HaveSearched As Boolean
Public hTimer As Long
Public Text(1 To 4, 100) As SkylderTextBox
Public Current As POINTAPI

Dim Buffer As Buffer

Public Sub DoColors()

Dim A%, B%

For A = 1 To UBound(Text, 1)
For B = 1 To UBound(Text, 2)
Text(A, B).BackColor = vbGreen
Next
Next

DrawAll

End Sub

Public Function GetTextBox(SkylderText() As String) As Integer

Name.Show
CancelIt = True

Do Until Name.Visible = False
Sleep 10
DoEvents
Loop

If CancelIt Then GetTextBox = 1: Exit Function

SkylderText(0) = Name.Text1.Text
SkylderText(1) = Name.Text2.Text
SkylderText(2) = Name.Text3.Text
SkylderText(3) = Name.Text4.Text

End Function

Public Sub FillInVarText()

Dim A%, B%
For A = 1 To UBound(Text, 1)
For B = 0 To 20
Text(A, B).ScaleWidth = Skylder.Picture1.ScaleWidth / UBound(Text, 1)
Text(A, B).ScaleHeight = Skylder.Picture1.ScaleHeight / 20
Text(A, B).TextColor = vbBlack
Text(A, B).LineColor = vbBlack

Select Case B
Case 0
Text(A, B).BackColor = vbYellow
If A = 1 Then Text(A, B).Text = "Name:"
If A = 2 Then Text(A, B).Text = "Phone:"
If A = 3 Then Text(A, B).Text = "What:"
If A = 4 Then Text(A, B).Text = "How much:"
Case Else: Text(A, B).BackColor = vbGreen
End Select

Next
Next

Skylder.VScroll1.Max = 100 - 25

End Sub

Public Sub DrawToPic()

BitBlt Skylder.Picture1.hdc, 0, 0, Skylder.Picture1.ScaleWidth, Skylder.Picture1.ScaleHeight, Buffer.hdc, 0, 0, vbSrcCopy

End Sub

Public Sub LoadBuffer()

Buffer.hdc = CreateCompatibleDC(Skylder.Picture1.hdc)
Buffer.Picture = CreateCompatibleBitmap(Skylder.Picture1.hdc, Skylder.Picture1.ScaleWidth, Skylder.Picture1.ScaleHeight)
Buffer.Font = CreateFont(16, 0, 0, 0, FW_NORMAL, False, False, False, OEM_CHARSET, OUT_DEFAULT_PRECIS, CLIP_MASK, DEFAULT_QUALITY, 34, "MS Sans Serif")
SelectObject Buffer.hdc, Buffer.Picture
SelectObject Buffer.hdc, Buffer.Font
DeleteObject Buffer.Font

End Sub

Public Function GetPos(TextBox As TextBox, ByVal X As Single) As Integer

If Skylder.Picture1.TextWidth(TextBox.Text) > X - TextBox.Left Then GetPos = Len(TextBox.Text): Exit Function

GetPos = (X - TextBox.Left) / Skylder.Picture1.TextWidth("A")

End Function

Public Sub DeleteBuffer()

DeleteDC Buffer.hdc
DeleteObject Buffer.Picture

End Sub

Public Sub DrawAll()

Dim A%, B%, Buff As POINTAPI
For A = 1 To UBound(Text, 1)
For B = 0 To 20
Buff.X = A
Buff.Y = B
DrawText Buff
Next
Next

BitBlt Skylder.Picture1.hdc, 0, 0, Skylder.Picture1.ScaleWidth, Skylder.Picture1.ScaleHeight, Buffer.hdc, 0, 0, vbSrcCopy

End Sub

Public Sub DrawText(Position As POINTAPI)

Buffer.Brush = CreateSolidBrush(Text(Position.X, Position.Y + Y).BackColor)
Buffer.Pen = CreatePen(0, 1, Text(Position.X, Position.Y + Y).LineColor)
SelectObject Buffer.hdc, Buffer.Brush
SelectObject Buffer.hdc, Buffer.Pen
SetBkMode Buffer.hdc, 1
SetTextColor Buffer.hdc, Text(Position.X, Position.Y + Y).TextColor

With Buffer.Rect
.Left = (Position.X - 1) * Text(Position.X, Position.Y + Y).ScaleWidth + 3
.Top = Position.Y * Text(Position.X, Position.Y + Y).ScaleHeight + 3
.Right = Buffer.Rect.Left + Text(Position.X, Position.Y + Y).ScaleWidth - 2
.Bottom = Buffer.Rect.Top + Text(Position.X, Position.Y + Y).ScaleHeight - 2
End With

Rectangle Buffer.hdc, Buffer.Rect.Left - 3, Buffer.Rect.Top - 3, Buffer.Rect.Right, Buffer.Rect.Bottom
DrawTextA Buffer.hdc, Text(Position.X, Position.Y + Y).Text, Len(Text(Position.X, Position.Y + Y).Text), Buffer.Rect, DT_LEFT And DT_VCENTER

DeleteObject Buffer.Brush
DeleteObject Buffer.Pen

End Sub

Public Function GetKeyValue(KeyRoot As Long, KeyName As String, SubKeyRef As String, ByRef KeyVal As String) As Boolean
    Dim I As Long
    Dim rc As Long
    Dim hKey As Long
    Dim hDepth As Long
    Dim KeyValType As Long
    Dim tmpVal As String
    Dim KeyValSize As Long

    rc = RegOpenKeyEx(KeyRoot, KeyName, 0, KEY_ALL_ACCESS, hKey)
    
    If (rc <> ERROR_SUCCESS) Then GoTo GetKeyError
    
    tmpVal = String$(1024, 0)
    KeyValSize = 1024
    
    rc = RegQueryValueEx(hKey, SubKeyRef, 0, _
                         KeyValType, tmpVal, KeyValSize)
                        
    If (rc <> ERROR_SUCCESS) Then GoTo GetKeyError
    
    If (Asc(Mid(tmpVal, KeyValSize, 1)) = 0) Then
        tmpVal = Left(tmpVal, KeyValSize - 1)
    Else
        tmpVal = Left(tmpVal, KeyValSize)
    End If

    Select Case KeyValType
    Case REG_SZ
        KeyVal = tmpVal
    Case REG_DWORD
        For I = Len(tmpVal) To 1 Step -1
            KeyVal = KeyVal + Hex(Asc(Mid(tmpVal, I, 1)))
        Next
        KeyVal = Format$("&h" + KeyVal)
    End Select
    
    GetKeyValue = True
    rc = RegCloseKey(hKey)
    Exit Function
    
GetKeyError:
    KeyVal = ""
    GetKeyValue = False
    rc = RegCloseKey(hKey)
End Function


